<template>
  <rui-form :errors="errors"
            model="resource"
            :loading="loading"
            @cancel="$emit('cancel')"
            @submit.prevent="save">
    <rui-alert variant="info">{{ $t('js.resources.form.community_alert') }}</rui-alert>

    <rui-field input-id="resource_name" :label="$t('activerecord.attributes.resource.name')">
      <input id="resource_name"
             v-model="inputs.name"
             type="text"
             name="name"
             autocomplete="off"
             required>
      <template #help>
        <div v-if="searchNamesResults.length > 0">
          {{ $t('js.resources.form.already_created') }}
          <rui-badge v-for="result in searchNamesResults"
                     :key="result"
                     :caption="result"
                     variant="help"
                     size="small" />
        </div>
      </template>
    </rui-field>

    <rui-field input-id="resource_latin_name" :label="$t('activerecord.attributes.resource.latin_name')" :help="$t('js.resources.form.latin_name_help')">
      <input id="resource_latin_name"
             v-model="inputs.latinName"
             type="text"
             name="latin_name"
             autocomplete="off"
             required>
    </rui-field>

    <rui-field input-id="resource_parent" :label="$t('activerecord.attributes.resource.parent')" :help="$t('js.resources.form.parent_help')">
      <multiselect id="resource_parent"
                   v-model="parent"
                   :disabled="resource && resource.generic"
                   :options="parentableResources"
                   :allow-empty="true"
                   track-by="id"
                   label="name" />
    </rui-field>

    <rui-field input-id="resource_resource_interactions_group" :label="$t('activerecord.attributes.resource.resource_interactions_group')" :help="$t('js.resources.form.resource_interactions_group_id_help')">
      <multiselect id="resource_resource_interactions_group"
                   v-model="resourceInteractionsGroup"
                   :options="resourceInteractionsGroups"
                   :allow-empty="true"
                   track-by="id"
                   label="name" />
    </rui-field>

    <rui-field input-id="resource_crop_rotation_group" :label="$t('activerecord.attributes.resource.crop_rotation_group')">
      <select id="resource_crop_rotation_group" v-model="inputs.cropRotationGroup" name="crop_rotation_group">
        <option value="" />
        <option v-for="group in cropRotationGroups" :key="group" :value="group">{{ $t(`activerecord.attributes.resource/crop_rotation_group.${group}`) }}</option>
      </select>
    </rui-field>

    <rui-field input-id="resource_common_names" :label="$t('activerecord.attributes.resource.common_names')">
      <input id="resource_common_names" v-model="inputs.commonNames" type="text" name="common_names">
    </rui-field>

    <rui-field input-id="resource_diameter" :label="$t('activerecord.attributes.resource.diameter')" append="m">
      <input id="resource_diameter"
             v-model="inputs.diameter"
             type="number"
             name="diameter"
             min="0"
             step="0.01">
    </rui-field>

    <rui-field input-id="resource_genus_id" :label="$t('activerecord.attributes.resource.genus')">
      <multiselect id="resource_genus_id"
                   v-model="genus"
                   :options="genera"
                   :allow-empty="false"
                   track-by="id"
                   label="name" />
    </rui-field>

    <rui-field input-id="tag_list" :label="$t('activerecord.attributes.resource.tag_list')" :help="$t('js.resources.form.tags_help')">
      <rui-tag-selector id="tag_list" v-model="inputs.tagList" :tags="tags" />
    </rui-field>

    <rui-field :label="$t('activerecord.attributes.resource.sheltered_sowing_months')">
      <gp-months-flags-input v-model="inputs.shelteredSowingMonths" input-name="sheltered_sowing_months" />
    </rui-field>
    <rui-field :label="$t('activerecord.attributes.resource.soil_sowing_months')">
      <gp-months-flags-input v-model="inputs.soilSowingMonths" input-name="soil_sowing_months" />
    </rui-field>
    <rui-field :label="$t('activerecord.attributes.resource.harvesting_months')">
      <gp-months-flags-input v-model="inputs.harvestingMonths" input-name="harvesting_months" />
    </rui-field>

    <rui-field input-id="resource_sources" :label="$t('activerecord.attributes.resource.sources')" :help="$t('js.resources.form.sources_help')">
      <textarea id="resource_sources" v-model="inputs.sources" name="sources" />
    </rui-field>

    <rui-field input-id="resource_description" :label="$t('activerecord.attributes.resource.description')">
      <textarea id="resource_description"
                v-model="inputs.description"
                name="description"
                class="-large" />
    </rui-field>
  </rui-form>
</template>
<script>
import { RESOURCE_CROP_ROTATION_GROUPS } from '../../../../../helpers/constants.js'
import debounce from 'debounce'
import Resource from '../../../../classes/models/Resource'
import Toaster from '../../../../tools/Toaster'

import Multiselect from 'vue-multiselect'

import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiBadge from '@experiments-labs/rise_ui/src/components/Badge/Badge.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'
import RuiTagSelector from '@experiments-labs/rise_ui/src/components/Inputs/TagSelector/TagSelector.vue'

import GpMonthsFlagsInput from '../../../../common/Inputs/MonthsFlags/MonthsFlags.vue'

export default {
  name: 'GpaResourceForm',
  emits: [
    'cancel',
    'saved',
  ],
  components: { RuiTagSelector, RuiBadge, RuiField, RuiForm, RuiAlert, Multiselect, GpMonthsFlagsInput },
  props: {
    resource: { required: false, type: Resource, default: null },
  },
  data () {
    return {
      inputs: { ...this.makeInputs() },
      nameSearch: '',
      cropRotationGroups: RESOURCE_CROP_ROTATION_GROUPS,
      // Selected parent; this is a Resource set by vue-multiselect
      resourceInteractionsGroup: this.initializeResourceInteractionsGroup(),
      parent: this.initializeParent(),
      genus: this.initializeGenus(),
      // Submission state
      errors: null,
      loading: false,
    }
  },
  computed: {
    layers () { return this.$store.getters.layers },
    genera () { return this.$store.getters.genera },
    resources () { return this.$store.getters.resources },
    resourceInteractionsGroups () { return this.$store.getters.resourceInteractionsGroups },
    parentableResources () { return this.$store.getters.parentableResources },
    searchNamesResults () { return this.$store.getters.resourceSearch(this.nameSearch).map(r => r.name) },
    tags () {
      const tags = this.resources.reduce((acc, r) => {
        acc.push(...r.tagList)
        return acc
      }, [])
      return tags.filter((tag, index) => tags.indexOf(tag) === index)
        .sort()
    },
  },
  methods: {
    initializeResourceInteractionsGroup () {
      if (this.$props.resource && this.$props.resource.resourceInteractionsGroupId) {
        const resourceInteractionsGroup = this.$props.resource.resourceInteractionsGroup
        return { id: resourceInteractionsGroup.id, name: resourceInteractionsGroup.name }
      }
      return null
    },
    initializeParent () {
      if (this.$props.resource && this.$props.resource.parentId) {
        const parent = this.$props.resource.parent
        return { id: parent.id, name: parent.name }
      }
      return null
    },
    initializeGenus () {
      if (this.$props.resource && this.$props.resource.genusId) {
        const genus = this.$props.resource.genus
        return { id: genus.id, name: genus.name }
      }
      return null
    },
    makeInputs () {
      const inputs = {
        id: null,
        name: '',
        latinName: '',
        description: '',
        diameter: null,
        parentId: null,
        layerId: null,
        genusId: null,
        cropRotationGroup: null,
        commonNames: '',
        sources: '',
        tagList: [],
        shelteredSowingMonths: Array(12).fill(false, 0, 12),
        soilSowingMonths: Array(12).fill(false, 0, 12),
        harvestingMonths: Array(12).fill(false, 0, 12),
        ...this.$props.resource,
      }

      if (Array.isArray(inputs.commonNames)) inputs.commonNames = inputs.commonNames.join(', ')
      if (Array.isArray(inputs.sources)) inputs.sources = inputs.sources.join('\n')

      return inputs
    },
    save () {
      const payload = {
        id: this.inputs.id,
        name: this.inputs.name,
        latin_name: this.inputs.latinName,
        description: this.inputs.description,
        diameter: this.inputs.diameter,
        parent_id: this.parent && !(this.resource && this.resource.generic) ? this.parent.id : null,
        resource_interactions_group_id: this.resourceInteractionsGroup ? this.resourceInteractionsGroup.id : null,
        crop_rotation_group: this.inputs.cropRotationGroup,
        layer_id: this.inputs.layerId,
        genus_id: this.genus ? this.genus.id : null,
        tag_list: this.inputs.tagList,
        sheltered_sowing_months: this.inputs.shelteredSowingMonths,
        soil_sowing_months: this.inputs.soilSowingMonths,
        harvesting_months: this.inputs.harvestingMonths,
        common_names: this.inputs.commonNames
          .split(',')
          .map(n => n.trim())
          .filter(n => n.length > 0),
        sources: this.inputs.sources
          .split('\n')
          .map(n => n.trim())
          .filter(n => n.length > 0),
      }
      if (!payload.id) { delete payload.id }

      this.loading = true
      this.errors = null
      this.$store.dispatch('saveResource', payload)
        .then(() => {
          Toaster.success(this.$t('js.generic.successfully_saved'))
          this.$emit('saved')
        })
        .catch((errors) => {
          Toaster.error(this.$t('js.generic.failed_to_save'))
          this.errors = errors
        })
        .then(() => { this.loading = false })
    },
    prefill () {
      if (!this.inputs.parentId) return

      const parent = this.$store.getters.resource(this.inputs.parentId)
      this.inputs.genusId = parent.genusId
      this.inputs.layerId = parent.layerId
    },
  },
  watch: {
    resource () {
      this.inputs = this.makeInputs()
      // Reset values for vue-multiselect
      this.parent = this.initializeParent()
      this.genus = this.initializeGenus()
    },
    'inputs.name': debounce(function () { this.nameSearch = this.inputs.name }, 250),
  },
}
</script>
